Package com.sas.services.information.metadata.prompt

# Interface BaseOMRPromptInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`

All Known Subinterfaces:
  `OMRPromptGroupInterface`

All Known Implementing Classes:
  `OMRPromptDefinition`, `OMRPromptGroup`

public interface BaseOMRPromptInterface extends MetadataInterface
The interface of methods common to all prompt model objects.

Since:
  9.2

- ## Field Summary

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addPromptReference(BaseOMRPromptInterface prompt)`
  Add the supplied prompt as a reference to this prompt, where this prompt is a shared prompt definition or group in a tree folder (therefore a public prompt).
  `void`
  `addReferencedPrompt(BaseOMRPromptInterface prompt)`
  Adds a referenced prompt (a shared prompt definition or prompt group that is in a tree folder) to the list of referenced prompts kept by this prompt object.
  `void`
  `addValueSource(MetadataInterface metaObject)`
  Adds the metaObject as a value source.
  `MetadataInterface`
  `getPromptEnabledObject()`
  Gets the metadata object associated with this prompt.
  `List`
  `getPromptReferences()`
  Returns a list of prompt references held by this prompt.
  `List`
  `getReferencedPrompts()`
  Returns a list of all referenced prompts (shared prompts in a tree folder) held by this prompt.
  `List`
  `getValueSources()`
  Returns a list of MetadataInterface items that are value sources for the prompt.
  `boolean`
  `isPublic()`
  `void`
  `removeAllPromptReferences()`
  Removes all prompt references such that this shared prompt is no longer linked to any other prompts.
  `void`
  `removeAllReferencedPrompts()`
  Removes all referenced prompts such that this prompt is no longer linked to any shared prompts.
  `void`
  `removeAllValueSources()`
  Removes all value sources associated with the prompt.
  `void`
  `removePromptEnabledObject()`
  Removes the prompt-enabled object associated with this prompt.
  `void`
  `removePromptReference(BaseOMRPromptInterface prompt)`
  Removes the supplied prompt from the list of prompt references held by this prompt.
  `void`
  `removeReferencedPrompt(BaseOMRPromptInterface prompt)`
  Remove the supplied prompt (a shared prompt in a tree folder) from the list of referenced prompts held by this prompt.
  `void`
  `setPromptEnabledObject(MetadataInterface metaObject)`
  Sets an association between the prompt and metaObject unless the prompt is public.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

- ## Method Details

  - ### setPromptEnabledObject

    void setPromptEnabledObject(MetadataInterface metaObject) throws RemoteException, ServiceException
    Sets an association between the prompt and metaObject unless the prompt is public. In that case a ServiceException is thrown.
    Parameters:
      `metaObject` -
    Throws:
      `RemoteException`
      `ServiceException`

  - ### getPromptEnabledObject

    MetadataInterface getPromptEnabledObject() throws RemoteException, ServiceException
    Gets the metadata object associated with this prompt.
    Returns:
      MetadataInterface
    Throws:
      `RemoteException`
      `ServiceException`

  - ### removePromptEnabledObject

    void removePromptEnabledObject() throws RemoteException, ServiceException
    Removes the prompt-enabled object associated with this prompt. Removal effectively orphans this prompt, so this prompt should either be deleted or associated with a different prompt-enabled object.
    Throws:
      `RemoteException`
      `ServiceException`

  - ### addValueSource

    void addValueSource(MetadataInterface metaObject) throws RemoteException, ServiceException
    Adds the metaObject as a value source. The value sources are used for metadata impact analysis. Impact analysis provides warnings when linked metadata objects are threatened by changes to a metadata object.
    Parameters:
      `metaObject` - MetadataInterface
    Throws:
      `RemoteException`
      `ServiceException`

  - ### getValueSources

    List getValueSources() throws RemoteException, ServiceException
    Returns a list of MetadataInterface items that are value sources for the prompt. If none exist, an empty list is returned.
    Returns:
      List with MetadataInterface items
    Throws:
      `RemoteException` - if network problems occur
      `ServiceException` - if problems occur accessing metadata

  - ### removeAllValueSources

    void removeAllValueSources() throws RemoteException, ServiceException
    Removes all value sources associated with the prompt.
    Throws:
      `RemoteException`
      `ServiceException`

  - ### addPromptReference

    void addPromptReference(BaseOMRPromptInterface prompt) throws RemoteException, ServiceException
    Add the supplied prompt as a reference to this prompt, where this prompt is a shared prompt definition or group in a tree folder (therefore a public prompt). The supplied prompt may not itself be a shared prompt. References may only exist between shared and unshared prompt objects. If `this.isPublic()` returns false, a ServiceException will be thrown. If `prompt.isPublic()` returns true, a ServiceException will be thrown.
    Parameters:
      `prompt` - the prompt to add as a reference
    Throws:
      `RemoteException`
      `ServiceException`

  - ### getPromptReferences

    List getPromptReferences() throws RemoteException, ServiceException
    Returns a list of prompt references held by this prompt. The references are to the prompt objects that link to this shared prompt.
    Returns:
      the list of BaseOMRPromptInterface objects
    Throws:
      `RemoteException`
      `ServiceException`

  - ### removePromptReference

    void removePromptReference(BaseOMRPromptInterface prompt) throws RemoteException, ServiceException
    Removes the supplied prompt from the list of prompt references held by this prompt.
    Parameters:
      `prompt` - to remove
    Throws:
      `RemoteException`
      `ServiceException`

  - ### removeAllPromptReferences

    void removeAllPromptReferences() throws RemoteException, ServiceException
    Removes all prompt references such that this shared prompt is no longer linked to any other prompts.
    Throws:
      `RemoteException`
      `ServiceException`

  - ### addReferencedPrompt

    void addReferencedPrompt(BaseOMRPromptInterface prompt) throws RemoteException, ServiceException
    Adds a referenced prompt (a shared prompt definition or prompt group that is in a tree folder) to the list of referenced prompts kept by this prompt object. This prompt may not be a shared, public prompt. References may only exist between shared and unshared prompt objects. If `this.isPublic()` returns true, a ServiceException will be thrown. If `prompt.isPublic()` returns false, a ServiceException will be thrown.
    Parameters:
      `prompt` - to add
    Throws:
      `RemoteException`
      `ServiceException`

  - ### getReferencedPrompts

    List getReferencedPrompts() throws RemoteException, ServiceException
    Returns a list of all referenced prompts (shared prompts in a tree folder) held by this prompt.
    Returns:
      the list of BaseOMRPromptInterface objects
    Throws:
      `RemoteException`
      `ServiceException`

  - ### removeReferencedPrompt

    void removeReferencedPrompt(BaseOMRPromptInterface prompt) throws RemoteException, ServiceException
    Remove the supplied prompt (a shared prompt in a tree folder) from the list of referenced prompts held by this prompt.
    Parameters:
      `prompt` - to remove
    Throws:
      `RemoteException`
      `ServiceException`

  - ### removeAllReferencedPrompts

    void removeAllReferencedPrompts() throws RemoteException, ServiceException
    Removes all referenced prompts such that this prompt is no longer linked to any shared prompts.
    Throws:
      `RemoteException`
      `ServiceException`

  - ### isPublic

    boolean isPublic() throws ServiceException, RemoteException
    Throws:
      `ServiceException`
      `RemoteException`